/* HickCmd 1.1.1 -- Command line interface to hick.
** Copyright (C) 1997 - 2001 Daniel Bergstrom <daniel@octocode.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _HICKCMD_H
#define _HICKCMD_H

#include "hick.h"
#include "hicksh.h"

#define PROGRAM_NAME           "hickcmd"
#define PROGRAM_VERSION        "1.1.1"

#define CHECK_NEW     (1<<1)
#define CHECK_CHANGED ((1<<2) | (1<<3) | (1<<4))

#ifdef __cplusplus
extern "C" {
#endif

extern int hick_command_line(int argc, char **argv);

/* defined in: file.c */

extern int _save_installed(const char *filename, const char *packpath,
                           const char *homepath, const char *hicktype);

extern int _load_install(const char *filename, HickPackets *pack);

extern int viewLogfile(const char *homepath, const char *hicktype);

/* defined in: check.c */

extern int _check_packets(const char *packpath, const char *homepath,
                          const char *hicktype, unsigned int mask,
                          time_t since);

#ifdef __cplusplus
}
#endif

#endif /* _HICKCMD_H */
