/* HickUP 1.2 -- Graphical interface to hick.
** Copyright (C) 1998 - 2001, 2008 Daniel Bergstrom <daniel@octocode.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _GPIXMAP_H
#define _GPIXMAP_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <gtk/gtkwidget.h>

/* GPixmap ***************************************************************** */

typedef struct {
  GdkPixmap *pix;
  GdkBitmap *mask;
} GPixmap;

/* DGPixmap **************************************************************** */

typedef struct {
  GPixmap open;
  GPixmap close;
} DGPixmap;

/* GUI_Pixmaps ************************************************************* */

typedef struct {
  GPixmap no;        /* for require and conflict */
  GPixmap yes;

  GPixmap dot;       /* indication that there's something here */
  GPixmap empty;     /* used for menu items without any pixmap */

  GPixmap select;    /* not selected */
  GPixmap dselected; /* default      */
  GPixmap forced;    /* forced       */
  GPixmap selected;  /* selected     */
  GPixmap attention; /* information  */

  DGPixmap group;
  DGPixmap packet;

  DGPixmap *pixmaps[4]; /* pointing at group, packet ... */
} GUI_Pixmaps;

#ifdef __cplusplus
extern "C" {
#endif

#define gpixmap_init(gpix)  (gpix)->pix = NULL, (gpix)->mask = NULL
#define dgpixmap_init(dgpix)  \
  gpixmap_init(&(dgpix)->open), gpixmap_init(&(dgpix)->close)

void gui_pixmap_init(GUI_Pixmaps *guip);
void gui_pixmap_create_dot(GUI_Pixmaps *guip, GtkWidget *window);
void gui_pixmap_create_all(GUI_Pixmaps *guip, GtkWidget *window);

#ifdef __cplusplus
}
#endif

#endif /* _GPIXMAP_H */
