/* HickUP 1.2 -- Graphical interface to hick.
** Copyright (C) 1998 - 2001, 2008 Daniel Bergstrom <daniel@octocode.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _GUI_H
#define _GUI_H

#include <gtk/gtkitemfactory.h>

#include "project.h"

/* GUI_Main **************************************************************** */

typedef struct {
  char menufile[FNAME_LEN + 1];

  GtkWidget *window;
  GtkItemFactory *factory;

  GtkWidget *bsearch; /* search button */

  GtkWidget *bok; /* button widgets */
  GtkWidget *bapply;
  GtkWidget *bcancel;

  guint sok; /* button signal ids */
  guint sapply;
  guint scancel;

  GUI_Pixmaps pixmaps;

  Projects projects;

  /* popup dialogs */

  GUI_Dialog view_log;
  GUI_Dialog search;
  GUI_Dialog_Msg about;
  GUI_Dialog_Err load_err_dialog;
} GUI_Main;

#ifdef __cplusplus
extern "C" {
#endif

extern GUI_Main _gmain;

extern void gui_main_init(GUI_Main *gmain, const char *prjsstr, char *user,
                          char *homedir, char *userdesc);

extern GtkWidget *gui_main_create(GUI_Main *gmain); /* in mainwin.c */

extern Node *gui_find_expand(const char *packet, const char *version, 
                             const char *type, Project *prj, int isedit);
extern void gui_select_expand(NodeTree *ntree, Project *prj, int isedit);

#ifdef __cplusplus
}
#endif

#endif /* _GUI_H */
