/* HickUP 1.2 -- Graphical interface to hick.
** Copyright (C) 1998 - 2001, 2008 Daniel Bergstrom <daniel@octocode.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _NODE_H
#define _NODE_H

#include "hick.h"
#include "memd.h"

/* Node ******************************************************************** */

typedef struct _node Node;

struct _node {
  Node *next;
  Node *prev;

  unsigned int flag;

  char *name;
};

/* NodeList **************************************************************** */

typedef struct {
  Node *head;
  Node *tail;
} NodeList;

#ifdef __cplusplus
extern "C" {
#endif

#define node_init(n) \
  (n)->next = (n)->prev = NULL, (n)->flag = 0, (n)->name = NULL

extern Node *node_move(Node *node, NodeList *from, NodeList *to);
extern Node *node_insert(Node *node, NodeList *to);

extern Node *node_find(const char *name, NodeList *list);
extern Node *node_find_recursive(const char *name, unsigned int type, 
                                 NodeList *list);

#define hsh_nodelist_init(l)  (l)->head = (l)->tail = NULL

extern Node *hsh_node_prepend(Node *node, NodeList *to);
extern Node *hsh_node_append(Node *node, NodeList *to);
extern Node *hsh_node_remove(Node *node, NodeList *from);

#ifdef __cplusplus
}
#endif


#endif /* _NODE_H */

