/* HickUP 1.2 -- Graphical interface to hick.
** Copyright (C) 1998 - 2001, 2008 Daniel Bergstrom <daniel@octocode.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _PREF_H
#define _PREF_H

#include <gtk/gtkwidget.h>

#include "hicksh.h"

#define MENUBAR_FILE  "menubar"
#define PREF_FILE     "preferences"
#define MENU_LEN      64


typedef struct {
  ArrayInfo arri;
  unsigned int all : 1;
} PrefArr;


typedef struct {
  char path[FNAME_LEN + 1]; /* path to preferences file */
  char *pfile;              /* filename */

  PrefArr scripts;
  PrefArr menus;

  char menu_sub[MENU_LEN + 1];

  unsigned short info_width;

  unsigned int auto_require    : 1; /* auto install required packets? */
  unsigned int show_errors     : 1;

  unsigned int report_expired  : 1; /* popup report on expired / removed */
  unsigned int report_expire   : 1; /* got expire */
  unsigned int report_modified : 1; /* modified or change of default */
  unsigned int report_conflict : 1; /* conflicting packets */
  unsigned int report_forced   : 1; /* update report: forced packets */

  unsigned int html_page : 1;
  unsigned int info_page : 1;
} Preferences;

#ifdef __cplusplus
extern "C" {
#endif

extern Preferences _pref;

extern void pref_init(int value, unsigned short width);
extern void pref_clear(void);
extern int pref_save(void);
extern int pref_load(void);

extern void cb_pref(GtkWidget *w, gpointer data);

#ifdef __cplusplus
}
#endif

#endif /* _PREF_H */
