/* HickUP 1.2 -- Graphical interface to hick.
** Copyright (C) 1998 - 2001, 2008 Daniel Bergstrom <daniel@octocode.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _UPDATE_H
#define _UPDATE_H

#include <sys/types.h>

#include "dialog.h"

/* Progress **************************************************************** */

typedef struct {
  GUI_Dialog dialog;

  size_t total;
  size_t current;

  GtkWidget *pbar;
  GtkWidget *label;
  GtkWidget *status;
} Progress;

#ifdef __cplusplus
extern "C" {
#endif

extern int update_is_running(void);
extern void update_set_running(int state);

extern int update_show_report(Project *prj);
extern void update_show(Project *prj);

extern void update_progress_bar_new(const char *title, size_t total, 
                                    Progress *pbar);

extern void update_run(Project *prj, Projects *prjs, Progress *pbar);
extern void update_run_mk(Project *prj, Projects *prjs, Progress *pbar);

extern void rescue_update(Project *prj, const char *type);

#ifdef __cplusplus
}
#endif

#endif /* _UPDATE_H */
