/* HMerge 1.0.3 -- Packet merger.
** Copyright (C) 2000 Daniel Bergstroem <daniel@octocode.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef HMERGE_H
#define HMERGE_H

#include "nodes.h"
#include "array.h"
#include "getpacket.h"

#define PROGRAM_NAME     "hmerge"
#define PROGRAM_VERSION  "1.0.3"

typedef struct {
  NodeNum num;

  char *filename;

  HickPacket pkg;
} HMergePacket;

extern void hmerge_unite_versions(NodeList *list);
extern int hmerge_merge_packets(HickPacket *pkg, NodeList *packets);
extern int hmerge_load_file(HMergePacket *mpkg);
extern int hmerge_get_weight(char *filename);

extern void hmerge_default_set(HickPacket *pkg, PArr *defs);
extern void hmerge_default_load(const char *filename, PArr *defs);

#endif /* HMERGE_H */
