/* HMerge 1.0.3 -- Packet merger.
** Copyright (C) 2000 Daniel Bergstroem <daniel@octocode.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include "hmerge.h"

void
hmerge_default_set(HickPacket *pkg, PArr *defs)
{
  HickVer *ver;
  int defset = 0;

  for(ver = pkg->pac_versions.vl_head; ver; ver = ver->ver_next) {
    ver->ver_default = 0;

    if(parr_find_value(defs, char, ver->ver_number, parr_strcasecmp)) {
      if(defset && !pkg->pac_multiple) {
        continue;
      }

      defset = 1;
      ver->ver_default = 1;
    }
  }

  if(!defs->siz && pkg->pac_versions.vl_head) {
    pkg->pac_versions.vl_head->ver_default = 1;
  }
}

void
hmerge_default_load(const char *filename, PArr *defs)
{
  FILE *file;

  if(!(file = fopen(filename, "r"))) {
    return;
  }

  

  fclose(file);
}
