/* HMod 1.0.1 -- Hick modules emulation.
** Copyright (C) 2000 - 2001 Daniel Bergstrom <daniel@octocode.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef HMODENV_H
#define HMODENV_H

#include <stdio.h>

#include "hick.h"
#include "nodes.h"

typedef struct {
  Node node;

  char *value;
} HModEnvValue;


typedef struct {
  Node node;

  char *name;
  NodeList values;
} HModEnvVar;


typedef struct {
  NodeList vars;
} HModEnv;


#ifdef __cplusplus
extern "C" {
#endif

#define hmod_env_init(henv) hsh_nodelist_init(&(henv)->vars);

extern void hmod_env_set(HModEnv *henv, const char *name, const char *value);
extern void hmod_env_unset(HModEnv *henv, const char *name);

extern void hmod_env_append(HModEnv *henv, const char *name,
                            const char *value);
extern void hmod_env_prepend(HModEnv *henv, const char *name,
                             const char *value);

extern void hmod_env_remove(HModEnv *henv, const char *name,
                            const char *value);

extern void hmod_env_print(FILE *file, HModEnv *henv, const char *name);

extern void hmod_env_value_append(HModEnvVar *hvar, const char *value);
extern void hmod_env_value_prepend(HModEnvVar *hvar, const char *value);
extern void hmod_env_value_clear(HModEnvVar *hvar);

extern int hmod_env_parse(HickPacket *hpkg, HModEnv *henv);

#ifdef __cplusplus
}
#endif

#endif /* HMODENV_H */
