/* HMod 1.0.1 -- Hick modules emulation.
** Copyright (C) 2000 - 2001 Daniel Bergstrom <daniel@octocode.com>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2, or (at your option)
** any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef HMODLOAD_H
#define HMODLOAD_H

#include "hick.h"
#include "array.h"
#include "hmodenv.h"

typedef int (*HModLoadVer)(HickPacket *hpkg, PArr *loaded, int tryadd, 
                           PArr *vers, int isdef, HickVerList *nouse);
typedef int (*HModLoadInsted)(HickPacket *hpkg, PArr *loaded, int tryadd);
typedef int (*HModLoadConflict)(HickPacket *hpkg, HickPackets *pkg, 
                                PArr *loaded, int tryadd, int confchk);
typedef void (*HModLoadEnv)(HickEnv *env, HModEnv *henv);
typedef void(*HModLoadLoaded)(PArr *loaded, const char *name, const char *ver);


typedef struct {
  HModLoadVer      func_ver;
  HModLoadInsted   func_insted;
  HModLoadConflict func_conflict;
  HModLoadEnv      func_env;
  HModLoadLoaded   func_loaded;
  int conflict_chk;
  int environ_rescue;
} HModLoadUpdate;


#ifdef __cplusplus
extern "C" {
#endif

extern void hmod_load_update(HModLoadUpdate *update, HModEnv *henv,
                             HickPackets *pkg, PArr *loaded, int tryadd,
                             char **packets, size_t siz);

extern void hmod_load_link_convert(HickPacket *hpkg);

#ifdef __cplusplus
}
#endif

#endif /* HMODLOAD_H */
