/* HICK Lib 1.3.2 -- User Profiler Library.
** Copyright (C) 1997 - 2000 Daniel Bergstrom <daniel@octocode.com>
**
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
**
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _ENTRY_H
#define _ENTRY_H

#include "hick.h"

#define initUserEntryList(ul) (ul)->ul_head = (ul)->ul_tail = NULL

#ifdef __cplusplus
extern "C" {
#endif

extern userEntry *_entryNew(const char *name, const char *version,
			    time_t datet, unsigned int flag,
			    userEntryList *to);

extern userEntry *_entryPrepend(userEntry *ue, userEntryList *to);
extern userEntry *_entryFind(const char *name, userEntryList *list);
extern userEntry *_entryFindVersion(const char *version, userEntryList *list);

extern userEntry *_entryFindTwo(const char *name, const char *version,
				userEntryList *list);

extern userEntry *_entryMove(userEntry *ue, userEntryList *from,
			     userEntryList *to);
extern void _entryMoveName(const char *name, userEntryList *from,
			   userEntryList *to);
extern void _entryMoveList(userEntryList *from, userEntryList *to);

extern userEntry *_entryRemove(userEntry *ue, userEntryList *from);
extern void _entryRemoveMatchVersion(userEntryList *l1, userEntryList *l2);

extern void _freeUserEntryList(userEntryList *list);

extern int _entryLoad(const char *filename, userEntryList *to);
extern char *_get_str_word(char *str, int delim, int endc, char *buf,
			   size_t maxlen);

#ifdef __cplusplus
}
#endif

#endif /* _ENTRY_H */
