/* HICK Lib 1.3.2 -- User Profiler Library.
** Copyright (C) 1997 - 2000 Daniel Bergstrom <daniel@octocode.com>
**
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
**
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _GETFILE_H
#define _GETFILE_H

#include <time.h>
#include <stdio.h>
#include <stdlib.h>

#include "memd.h"

#define REALLOC_SIZE 32		/* Size it will add when it needs to realloc */

#define _addChar(buf, siz, asiz, ch) \
  if((siz + 1) > asiz) { \
    asiz += REALLOC_SIZE; \
    buf = ReMallocArr(buf, char, asiz); \
  } \
  buf[siz++] = ch

#ifdef __cplusplus
extern "C" {
#endif

extern char *_getName(FILE *file, char *buf, size_t maxlen);
extern char *_getString(FILE *file);
extern long _getNumber(FILE *file);
extern time_t _getTime(FILE *file);
extern void _getComment(FILE *file);
extern int _getSpaces(FILE *file);

extern void _readStmt(FILE *file, int start);
extern void _readString(FILE *file, int start);

#ifdef __cplusplus
}
#endif

#endif /* _GETFILE_H */
