/* HICK Lib 1.3.2 -- User Profiler Library.
** Copyright (C) 1997 - 2000 Daniel Bergstrom <daniel@octocode.com>
**
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
**
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _GETPACKET_H
#define _GETPACKET_H

#include "hick.h"

#define TOKEN_ABOUT     100
#define TOKEN_HIDDEN    101
#define TOKEN_REQUIRED  102
#define TOKEN_MULTIPLE  103
#define TOKEN_CREATED   104
#define TOKEN_MODIFIED  105
#define TOKEN_EXPIRE    106
#define TOKEN_SUBGROUP  107
#define TOKEN_VERSION   108
#define TOKEN_ALLOW     109
#define TOKEN_DENY      110
#define TOKEN_FORCE     111
#define TOKEN_ADDABOUT  112

/* For use in the _checkDirection(). */

#define PERM_ALLOW  0
#define PERM_DENY   1
#define PERM_FORCE  2

#define initDoubleArray(arr) \
  hsh_array_init(&(arr)->arr1);  hsh_array_init(&(arr)->arr2); \

/* DoubleArray ************************************************************* */

typedef struct {
  ArrayInfo arr1;
  ArrayInfo arr2;
} DoubleArray;

/* FileToken *************************************************************** */

typedef struct {
  const char *name;
  int token;
} FileToken;

/* Externs ***************************************************************** */

#ifdef __cplusplus
extern "C" {
#endif

extern FileToken _tokens[];

extern int _token_case_cmp(const char *s1, const char *s2);
extern int _token_lookup(const char *s, FileToken *tokens);

extern int _getPacketHead(FILE *file, HickEntry *result);

extern void _getPacket(FILE *file, const char *type, HickPacket *hpac,
		       int sabout);

extern HickDirection *_getDirection(FILE *file, HickDirection **head,
				    int force);

extern HickSubGroup *_getSubgroup(FILE *file, int ongroup);

extern int _getList(FILE *file, ArrayInfo *arri);

extern int _checkDirection(HickDirection *head, int flag, DoubleArray *arr);

#ifdef __cplusplus
}
#endif

#endif /* _GETPACKET_H */
