/* HICK Lib 1.3.2 -- User Profiler Library.
** Copyright (C) 1997 - 2000 Daniel Bergstrom <daniel@octocode.com>
**
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
**
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _HICKENV_H
#define _HICKENV_H

#include "hick.h"

#define initHickEnvList(el) (el)->el_head = (el)->el_tail = NULL;

#ifdef __cplusplus
extern "C" {
#endif

extern void _getEnv(FILE *file, int var, HickEnvList *list,
		    const char *hicktype, unsigned int defpri);

extern void _freeHickRequirePacket(HickRequirePacket *head);

extern void _envMoveList(HickEnvList *from, HickEnvList *to);
extern HickEnv *_envRemove(HickEnv *env, HickEnvList *from);

#ifdef __cplusplus
}
#endif

#endif /* _HICKENV_H */
