/* HICK Lib 1.3.2 -- User Profiler Library.
** Copyright (C) 1997 - 2000 Daniel Bergstrom <daniel@octocode.com>
**
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
**
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _LINKER_H
#define _LINKER_H

#include <stdio.h>

/* these values must be the same as HFLAG_LINK_NORMAL and HFLAG_LINK_RENAME */

#define LINK_NORMAL 0
#define LINK_RENAME 1

#ifdef __cplusplus
extern "C" {
#endif

extern int _createLinks(const char *to, const char *userhome,
			const char *basedir, const char *from, int flag,
			FILE *pathFile, FILE *logFile);

extern int _removeLinks(FILE *logfile, const char *filename,
			const char *basedir);

extern void _getFilename(char *filename, char *path, const char *s, int len);

extern char *_expandPath(char *buf, unsigned int size, const char *path,
			 const char *userhome, const char *stdpath);

#ifdef __cplusplus
}
#endif

#endif /* _LINKER_H */
