/* HICK Lib 1.3.2 -- User Profiler Library.
** Copyright (C) 1997 - 2000 Daniel Bergstrom <daniel@octocode.com>
**
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
**
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef _VERSION_H
#define _VERSION_H

#include "hick.h"

#define initHickVerList(vl)  (vl)->vl_head = (vl)->vl_tail = NULL

#ifdef __cplusplus
extern "C" {
#endif
  
extern HickVer *_versionAppend(HickVer *ver, HickVerList *to);
extern HickVer *_versionFind(const char *s, HickVerList *list);
extern HickVer *_versionMove(HickVer *ver, HickVerList *from, HickVerList *to);
extern void _versionMoveList(HickVerList *from, HickVerList *to);
extern HickVer *_versionRemove(HickVer *ver, HickVerList *from);

extern HickVer *_getVersion(HickVerList *list, FILE *file, int hver,
			    const char *hicktype, int sabout);

extern int _versionPermissions(HickVerList *list, HickDirection *allow,
			       HickDirection *deny, HickVerList *deniedList);

#ifdef __cplusplus
}
#endif


#endif /* _VERSION_H */
