/* HickMK 1.2.2 -- HICK Make Utility.
** Copyright (C) 1998 - 2001 Daniel Bergstrom <daniel@octocode.com>
**
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
**
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <unistd.h>

#include "hickmk.h"
#include "hicksh.h"
#include "hstring.h"

#include "common.h"

char *
hickmk_exec_build(const char *homepath, const char *hicktype)
{
  FILE *file;
  HString str;
  char path[FNAME_LEN + 1], oldfile[FNAME_LEN + 1], buf[FNAME_LEN + 1];

  hsh_create_str(path, FNAME_LEN, homepath, "/", SCRIPTS_DIR, "/",
                 hicktype, "/build", NULL);

  if(access(path, F_OK) == -1) {
    return 0;
  }

  if((file = popen(path, "r"))) {
    hstring_init(&str);

    while(fgets(buf, FNAME_LEN, file)) {
      hstring_add_string(&str, buf, strlen(buf));
    }

    hsh_create_str(oldfile, FNAME_LEN, path, ".old", NULL);

    rename(path, oldfile);
    pclose(file);
    return hstring_data(&str);
  }

  return 0;
}
