/* HickSH 1.1.2 -- Shared routines between hick parts.
** Copyright (C) 1999 - 2001 Daniel Bergstrom <daniel@octocode.com>
**
** This library is free software; you can redistribute it and/or
** modify it under the terms of the GNU Library General Public
** License as published by the Free Software Foundation; either
** version 2 of the License, or (at your option) any later version.
**
** This library is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
** Library General Public License for more details.
**
** You should have received a copy of the GNU Library General Public
** License along with this library; if not, write to the Free
** Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "hicksh.h"
#include "fileenable.h"


void
file_enable(const char *filename)
{
  int fd = open(filename, O_CREAT, 0);

  if(fd != -1) {
    close(fd);
  }
}


void 
file_disable(const char *filename)
{
  hsh_unlink(filename, NULL);
}


int 
file_status(const char *filename)
{
  struct stat sbuf;

  return (hsh_stat(filename, &sbuf, NULL) == IOW_OK ? 1 : 0);
}
