package Types;

use strict;

my $hicktype_prog = "@bindir@/get-hicktype";
my $hickroot_prog = "@bindir@/get-hickroot";

sub check(@) {
    use Env qw(HICKROOT HICKTYPE HOME OSTYPE);

    $HICKTYPE = shift @_ if($#_ >= 0);
    $HICKROOT = shift @_ if($#_ >= 0);

    return 0 if($#_ != -1);

    return (check_HICKTYPE() && check_HICKROOT());
}


sub check_HICKTYPE {
    if(! defined $HICKTYPE) {
	if( -x $hicktype_prog && defined ($HICKTYPE = `$hicktype_prog`)) {
	    chomp $HICKTYPE;

	    if($HICKTYPE ne "") {
		print "No HICKTYPE set, using '$HICKTYPE'.\n";
		return 1;
	    }
	}

	print "Failed to get HICKTYPE - aborting.\n" ;
	return 0;
    }

    return 1;
}


sub check_HICKROOT {
    if(! defined $HICKROOT) {
	if( -x $hickroot_prog && defined ($HICKROOT = `$hickroot_prog`)) {
	    chomp $HICKROOT;

	    if($HICKROOT ne "") {
		print "No HICKROOT set, using '$HICKROOT'.\n";
		return 1;
	    }
	}

	print "Failed to get HICKROOT - aborting.\n" ;
	return 0;
    }

    return 1;
}

1;
