#!@PERL@ -w
use strict;
use lib '@prefix@/lib';
use Getopt::Long;
use hick::Types;
use hick::Project;
use Env qw(USER LD_LIBRARY_PATH);

my ($path, $prog, $suff) = $0 =~ m,(.*/)?([^./]*)(.*)?$,;
my $hickbin  = "@bindir@";
my $userinfo = "-d @datadir@/hick/users.info";
my $title    = "-T \"Project Chooser\"";
my $tflag    = "";

my $usage = <<END;
Usage: $prog [ OPTIONS... ] [ HICKTYPE ] [ HICKROOT ]

	-h, --help         Prints this help text
	-t SECONDS,
	--timeout=SECONDS  Set timeout in seconds.
	-n, --nochange     Do not change into group, print project instead.
END

use vars qw/ $opt_h $opt_t $opt_n /;
my %opts = ("h"        => \$opt_h, "help"      => \$opt_h,
	    "t=i"      => \$opt_t, "timeout=i" => \$opt_t,
	    "n"        => \$opt_n, "nochange"  => \$opt_n
	    );

Getopt::Long::Configure("no_ignore_case");
GetOptions(%opts) || die $usage;

die $usage if(defined $opt_h || !Types::check(@ARGV));

$tflag = "-t $opt_t" if $opt_t;

$LD_LIBRARY_PATH = "@GTKLIBS@" . 
    (defined $LD_LIBRARY_PATH ? ":$LD_LIBRARY_PATH" : "");

my $hickprjs = Project::gets("");

if($hickprjs) {
    my $userhickuproot = `$hickbin/get-userhickuproot`;
    chomp $userhickuproot;
    open(HICKPRJ, "$hickbin/hickprj.bin -P $userhickuproot $tflag $userinfo $title $hickprjs|") ||
        die "Can't execute hickprj: $!\n";

    my $prjstr = <HICKPRJ>;
    die "$prog: failed to execute hickprj!\n" unless defined $prjstr;
    chomp $prjstr;
    close(HICKPRJ);

    Project::update_projectrc();

    my ($proj, $subproj) = Project::get_project($prjstr);

    if($proj ne $USER || $subproj) {
	my $project_root = Project::get_project_root($proj, $subproj);

	if($opt_n) {
	    print "$project_root:$proj" . ($subproj ? ":$subproj\n" : "\n");
	} else {
	    Project::enter($project_root, $proj, $subproj);
	}

	exit;
    }

    print "::\n" if($opt_n);
}
